
// ### 注意 ###
// ### prescription.js, usageEditor.jp, groupEditor.js でメソッド名が重複しないこと
// ###########

var _youhouType = 0; // Global 変数

///////////////////////////
/// Ajax による処理

function usageSelected(elm){
    // 用法ポップアップメニューが選択された
    if (elm.value == "...その他"){
        if (item = prompt("登録したい用法を入力してください")){
            console.log("usageSelected", item); //###
            var freq = 1;
            if (item.length == 0){
                alert("入力欄が空です");
            } else {
                save(item, 1);
            }
        }
    }
}
function loaded(answer){
    // 登録された用法のポップアップメニューを生成
    var array = usageList(answer);
    
    // 用法ポップアップメニュー
    var elm = elmFor("groupList");
    elm.innerHTML = "";
    var pm = newPopupMenu(elm, "usageNamePop", array, "");
    pm.setAttribute("onchange", "usageSelected(this)");

    // 削除アイコン
    var im = newIMAGE(elm, "removeUsage/expandIcon", "./remove-field.png", "X");
    im.setAttribute("onclick", "removeUsage()");
    im.style.height = "12px";
    im.style.marginLeft = "5px";
    setInfoTip("removeUsage", "この用法を削除"); // INFO

	function usageList(buff){
		// 用法リストを HTML 形式にして返す
		var array = eval('(' + buff + ')');
		var results = new Array();
		var i, j, count = array.length;
		for (i=j=0; i < count; i++){
			var obj = array[i];
			if (obj.type == selectedType()){
				var item = obj.value;
                results[j++] = item;
			}
		}
        results[j++] = "...その他";
        return results;
	}
}
function loadUsage(){
	// 用法データすべてをリクエスト
    _callServer("GET_USAGE_LIST", priceListServer(), null, loaded);
}

function saved(answer){
	// 用法の登録依頼に対するサーバからのレスポンスを処理
    loadUsage();
}
function save(item, freq){
	// 用法の登録依頼
    var args = new Object();
    args['item'] = item;
    args['freq'] = freq;
    args['type'] = selectedType();
    
    _callServer("PUT_USAGE", priceListServer(), args, saved);
}

function removedUsage(answer){
    loadUsage();
}
function removeUsage(){
	// 用法の削除
    var item = elmFor("usageNamePop").value;
    if (confirm("( " + item + " ) を削除していいですか")){
        var args = new Object();
        args['item'] = item;
        args['type'] = selectedType();
        
        _callServer("REMOVE_USAGE", priceListServer(), args, removedUsage);
    }
}

/// Ajax による処理
///////////////////////////


function selectedType(){
	return _youhouType; // function名と定数名は異なること
}

function selectedUsageRadio(){
    // ラジオボタンで選択された code を _youhouType として記憶
    var label = checkedRADIO("_radioArea");
    _youhouType = keyForValueIn(_tabObjects, label);
    loadUsage(); // _youhouType に該当するレコードを DB から読み込む
}
function setSelector(label){
    var labels = ["内用", "屯用", "外用"];
    var elm = document.getElementById("usageSelector");
    var bt = newRADIO(elm, "_radioArea", "modeButtons", labels, label);
    bt.setAttribute("onchange", "selectedUsageRadio()");
}

function closeUsageEditor(){
	document.getElementById("pr_editorArea").innerHTML = "";
    closeInfoTip();
}

function showUsageEditor(){
	var elm = document.getElementById("pr_editorArea");
	if (elm.innerHTML.length > 0){
		elm.innerHTML = "";
		return;
	}
    
    var frame = newDIV(elm, "templateFrame");
    frame.style.backgroundColor = "#ffe";
    frame.style.padding = "20px";
    frame.style.fontSize = "9pt";
    
    // HEADER =================================================
    var header = newDIV(frame, "/yellow-bar");
    header.style.padding = "2px 0 0 5px";
    var div = newDIV(header, "/clearfix");
    // --- HEADER LEFT -------------------------
    var left = newDIV(div, "/left-side");
    left.style.width = "60%";
    // クローズ・アイコン
	var im = newIMAGE(left,"usageCloseIcon/expandIcon","./close.png","close");
    im.style.height = "12px";
    im.style.position = "relative";
    im.style.top = "2px";
	im.setAttribute("onclick", "closeUsageEditor()");
    setInfoTip("usageCloseIcon", "用法編集を閉じる"); // INFO
    // ヘッダー・ラベル
    var dv = newSPAN(left, "");
    dv.style.paddingLeft = "10px";
    dv.innerHTML = "用法編集";

    // --- HEADER RIGHT ------------------------
    var right = newDIV(div, "/right-side");
    right.style.paddingRight = "10px";
    var im = newIMAGE(right, "usageHelpIcon", "./help.png", "?");
    im.setAttribute("onclick", "openHelp('./PrescUsageHelp.html')");
    im.style.height = "18px";
    im.setAttribute("class", "expandIcon");
    setInfoTip("usageHelpIcon", "HELP"); // INFO

	// ラジオボタン表示エリア ========================================
    var div = newDIV(frame, "usageSelector");
    div.style.margin = "8px 0 5px 13px";

    // 用法ポップアップメニュー表示エリア ===============================
    var div = newDIV(frame, "groupList");
    div.style.marginLeft = "10px";
	
    // ラジオボタンを表示
	setSelector("内用");
    selectedUsageRadio(); // 選択されたラジオボタンに対応する用法を load
}



